// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using System.Linq;

    /// <summary>
    /// Windows operating system settings to apply to the virtual machine.
    /// </summary>
    public partial class WindowsConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the WindowsConfiguration class.
        /// </summary>
        public WindowsConfiguration() { }

        /// <summary>
        /// Initializes a new instance of the WindowsConfiguration class.
        /// </summary>
        /// <param name="enableAutomaticUpdates">Whether automatic updates are
        /// enabled on the virtual machine.</param>
        public WindowsConfiguration(bool? enableAutomaticUpdates = default(bool?))
        {
            EnableAutomaticUpdates = enableAutomaticUpdates;
        }

        /// <summary>
        /// Gets or sets whether automatic updates are enabled on the virtual
        /// machine.
        /// </summary>
        /// <remarks>
        /// If omitted, the default value is true.
        /// </remarks>
        [Newtonsoft.Json.JsonProperty(PropertyName = "enableAutomaticUpdates")]
        public bool? EnableAutomaticUpdates { get; set; }

    }
}
