// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Gallery;

namespace Microsoft.Azure.Gallery
{
    /// <summary>
    /// A gallery item product definition.
    /// </summary>
    public partial class Product
    {
        private string _displayName;
        
        /// <summary>
        /// Optional. Gets or sets product display name.
        /// </summary>
        public string DisplayName
        {
            get { return this._displayName; }
            set { this._displayName = value; }
        }
        
        private string _legalTermsUri;
        
        /// <summary>
        /// Optional. Gets or sets product legal terms Uri.
        /// </summary>
        public string LegalTermsUri
        {
            get { return this._legalTermsUri; }
            set { this._legalTermsUri = value; }
        }
        
        private OfferDetails _offerDetails;
        
        /// <summary>
        /// Optional. Gets or sets product offer details.
        /// </summary>
        public OfferDetails OfferDetails
        {
            get { return this._offerDetails; }
            set { this._offerDetails = value; }
        }
        
        private string _pricingDetailsUri;
        
        /// <summary>
        /// Optional. Gets or sets product pricing details Uri.
        /// </summary>
        public string PricingDetailsUri
        {
            get { return this._pricingDetailsUri; }
            set { this._pricingDetailsUri = value; }
        }
        
        private string _privacyPolicyUri;
        
        /// <summary>
        /// Optional. Gets or sets product privacy policy Uri.
        /// </summary>
        public string PrivacyPolicyUri
        {
            get { return this._privacyPolicyUri; }
            set { this._privacyPolicyUri = value; }
        }
        
        private string _publisherDisplayName;
        
        /// <summary>
        /// Optional. Gets or sets product publisher display name.
        /// </summary>
        public string PublisherDisplayName
        {
            get { return this._publisherDisplayName; }
            set { this._publisherDisplayName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Product class.
        /// </summary>
        public Product()
        {
        }
    }
}
