// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.KeyVault.Models
{
    using Microsoft.Rest;
    using System;
    using System.Net.Http;
    using System.Runtime.Serialization;
#if !PORTABLE 
    using System.Security.Permissions;
#endif

    /// <summary>
    /// Exception thrown for an invalid response with KeyVaultError
    /// information.
    /// </summary>
#if !PORTABLE 
    [Serializable]
#endif
    public class KeyVaultErrorException : RestException
    {
        /// <summary>
        /// Gets information about the associated HTTP request.
        /// </summary>
        public HttpRequestMessageWrapper Request { get; set; }

        /// <summary>
        /// Gets information about the associated HTTP response.
        /// </summary>
        public HttpResponseMessageWrapper Response { get; set; }

        /// <summary>
        /// Gets or sets the body object.
        /// </summary>
        public KeyVaultError Body { get; set; }

        /// <summary>
        /// Return the service message if available, otherwise returns the general message
        /// </summary>
        public override string Message
        {
            get
            {
                if(Body != null && Body.Error != null && !string.IsNullOrWhiteSpace(Body.Error.Message))
                    return Body.Error.Message;
                return base.Message;
            }
        }

        /// <summary>
        /// Initializes a new instance of the KeyVaultErrorException class.
        /// </summary>
        public KeyVaultErrorException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the KeyVaultErrorException class.
        /// </summary>
        /// <param name="message">The exception message.</param>
        public KeyVaultErrorException(string message)
            : this(message, null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the KeyVaultErrorException class.
        /// </summary>
        /// <param name="message">The exception message.</param>
        /// <param name="innerException">Inner exception.</param>
        public KeyVaultErrorException(string message, Exception innerException)
            : base(message, innerException)
        {
        }

#if !PORTABLE 
        /// <summary>
        /// Initializes a new instance of the KeyVaultErrorException class.
        /// </summary>
        /// <param name="info">Serialization info.</param>
        /// <param name="context">Streaming context.</param>
        protected KeyVaultErrorException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

        /// <summary>
        /// Serializes content of the exception.
        /// </summary>
        /// <param name="info">Serialization info.</param>
        /// <param name="context">Streaming context.</param>
        /// <exception cref="ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        [SecurityPermission(SecurityAction.Demand, SerializationFormatter = true)]
        public override void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            base.GetObjectData(info, context);
            if (info == null)
            {
                throw new ArgumentNullException("info");
            }

            info.AddValue("Request", Request);
            info.AddValue("Response", Response);
            info.AddValue("Body", Body);
        }
#endif
    }
}
