// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Batch.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Contains information about an Azure Batch account.
    /// </summary>
    [JsonTransformation]
    public partial class AccountResource : Resource
    {
        /// <summary>
        /// Initializes a new instance of the AccountResource class.
        /// </summary>
        public AccountResource() { }

        /// <summary>
        /// Initializes a new instance of the AccountResource class.
        /// </summary>
        public AccountResource(int coreQuota, int poolQuota, int activeJobAndJobScheduleQuota, string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string accountEndpoint = default(string), AccountProvisioningState? provisioningState = default(AccountProvisioningState?), AutoStorageProperties autoStorage = default(AutoStorageProperties))
            : base(id, name, type, location, tags)
        {
            AccountEndpoint = accountEndpoint;
            ProvisioningState = provisioningState;
            AutoStorage = autoStorage;
            CoreQuota = coreQuota;
            PoolQuota = poolQuota;
            ActiveJobAndJobScheduleQuota = activeJobAndJobScheduleQuota;
        }

        /// <summary>
        /// Gets or sets the endpoint used by this account to interact with
        /// the Batch services.
        /// </summary>
        [JsonProperty(PropertyName = "properties.accountEndpoint")]
        public string AccountEndpoint { get; set; }

        /// <summary>
        /// Gets or sets the provisioned state of the resource. Possible
        /// values include: 'Invalid', 'Creating', 'Deleting', 'Succeeded',
        /// 'Failed', 'Cancelled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public AccountProvisioningState? ProvisioningState { get; set; }

        /// <summary>
        /// Gets or sets the properties and status of any auto storage account
        /// associated with the account.
        /// </summary>
        [JsonProperty(PropertyName = "properties.autoStorage")]
        public AutoStorageProperties AutoStorage { get; set; }

        /// <summary>
        /// Gets or sets the core quota for this Batch account.
        /// </summary>
        [JsonProperty(PropertyName = "properties.coreQuota")]
        public int CoreQuota { get; set; }

        /// <summary>
        /// Gets or sets the pool quota for this Batch account.
        /// </summary>
        [JsonProperty(PropertyName = "properties.poolQuota")]
        public int PoolQuota { get; set; }

        /// <summary>
        /// Gets or sets the active job and job schedule quota for this Batch
        /// account.
        /// </summary>
        [JsonProperty(PropertyName = "properties.activeJobAndJobScheduleQuota")]
        public int ActiveJobAndJobScheduleQuota { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (this.AutoStorage != null)
            {
                this.AutoStorage.Validate();
            }
        }
    }
}
