// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DataLake.Store.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// A WebHDFS exception thrown indicating the append or read is from a bad
    /// offset. Thrown when a 400 error response code is returned for append
    /// and open operations (Bad request).
    /// </summary>
    [JsonObject("BadOffsetException")]
    public partial class AdlsBadOffsetException : AdlsRemoteException
    {
        /// <summary>
        /// Initializes a new instance of the AdlsBadOffsetException class.
        /// </summary>
        public AdlsBadOffsetException() { }

        /// <summary>
        /// Initializes a new instance of the AdlsBadOffsetException class.
        /// </summary>
        /// <param name="javaClassName">the full class package name for the
        /// exception thrown, such as
        /// 'java.lang.IllegalArgumentException'.</param>
        /// <param name="message">the message associated with the exception
        /// that was thrown, such as 'Invalid value for webhdfs parameter
        /// "permission":...'.</param>
        public AdlsBadOffsetException(string javaClassName = default(string), string message = default(string))
            : base(javaClassName, message)
        {
        }

    }
}
