// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Insights
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;

    /// <summary>
    /// Composite Swagger for Insights Client
    /// </summary>
    public partial interface IInsightsClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        Newtonsoft.Json.JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        Newtonsoft.Json.JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        Microsoft.Rest.ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// The Azure subscription Id.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// Gets or sets the preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// Gets or sets the retry timeout in seconds for Long Running
        /// Operations. Default value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// When set to true a unique x-ms-client-request-id value is
        /// generated and included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IUsageMetricsOperations.
        /// </summary>
        IUsageMetricsOperations UsageMetrics { get; }

        /// <summary>
        /// Gets the IEventCategoriesOperations.
        /// </summary>
        IEventCategoriesOperations EventCategories { get; }

        /// <summary>
        /// Gets the IEventsOperations.
        /// </summary>
        IEventsOperations Events { get; }

        /// <summary>
        /// Gets the ITenantEventsOperations.
        /// </summary>
        ITenantEventsOperations TenantEvents { get; }

        /// <summary>
        /// Gets the IMetricDefinitionsOperations.
        /// </summary>
        IMetricDefinitionsOperations MetricDefinitions { get; }

        /// <summary>
        /// Gets the IMetricsOperations.
        /// </summary>
        IMetricsOperations Metrics { get; }

    }
}
