// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.IotHub.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The properties describing a Job Response.
    /// </summary>
    public partial class JobResponse
    {
        /// <summary>
        /// Initializes a new instance of the JobResponse class.
        /// </summary>
        public JobResponse() { }

        /// <summary>
        /// Initializes a new instance of the JobResponse class.
        /// </summary>
        public JobResponse(string jobId = default(string), DateTime? startTimeUtc = default(DateTime?), DateTime? endTimeUtc = default(DateTime?), string type = default(string), JobStatus? status = default(JobStatus?), string failureReason = default(string), string statusMessage = default(string), string deviceId = default(string), string parentJobId = default(string))
        {
            JobId = jobId;
            StartTimeUtc = startTimeUtc;
            EndTimeUtc = endTimeUtc;
            Type = type;
            Status = status;
            FailureReason = failureReason;
            StatusMessage = statusMessage;
            DeviceId = deviceId;
            ParentJobId = parentJobId;
        }

        /// <summary>
        /// The job identifier.
        /// </summary>
        [JsonProperty(PropertyName = "jobId")]
        public string JobId { get; set; }

        /// <summary>
        /// Start time of the Job.
        /// </summary>
        [JsonProperty(PropertyName = "startTimeUtc")]
        public DateTime? StartTimeUtc { get; set; }

        /// <summary>
        /// Represents the time the job stopped processing.
        /// </summary>
        [JsonProperty(PropertyName = "endTimeUtc")]
        public DateTime? EndTimeUtc { get; set; }

        /// <summary>
        /// The type of job to execute. Possible values include: 'unknown',
        /// 'export', 'import', 'backup', 'readDeviceProperties',
        /// 'writeDeviceProperties', 'updateDeviceConfiguration',
        /// 'rebootDevice', 'factoryResetDevice', 'firmwareUpdate'
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Status of the Job. Possible values include: 'unknown', 'enqueued',
        /// 'running', 'completed', 'failed', 'cancelled'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public JobStatus? Status { get; set; }

        /// <summary>
        /// If status == failure, this represents a string containing the
        /// reason.
        /// </summary>
        [JsonProperty(PropertyName = "failureReason")]
        public string FailureReason { get; set; }

        /// <summary>
        /// The status message for the job.
        /// </summary>
        [JsonProperty(PropertyName = "statusMessage")]
        public string StatusMessage { get; set; }

        /// <summary>
        /// The deviceId related to this response.
        /// </summary>
        [JsonProperty(PropertyName = "deviceId")]
        public string DeviceId { get; set; }

        /// <summary>
        /// The jobId of the parent job, if any.
        /// </summary>
        [JsonProperty(PropertyName = "parentJobId")]
        public string ParentJobId { get; set; }

    }
}
