// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Logic.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    public partial class EdifactDelimiterOverride
    {
        /// <summary>
        /// Initializes a new instance of the EdifactDelimiterOverride class.
        /// </summary>
        public EdifactDelimiterOverride() { }

        /// <summary>
        /// Initializes a new instance of the EdifactDelimiterOverride class.
        /// </summary>
        public EdifactDelimiterOverride(string messageId = default(string), string messageVersion = default(string), string messageRelease = default(string), int? dataElementSeparator = default(int?), int? componentSeparator = default(int?), int? segmentTerminator = default(int?), int? repetitionSeparator = default(int?), SegmentTerminatorSuffix? segmentTerminatorSuffix = default(SegmentTerminatorSuffix?), EdifactDecimalIndicator? decimalPointIndicator = default(EdifactDecimalIndicator?), int? releaseIndicator = default(int?), string messageAssociationAssignedCode = default(string), string targetNamespace = default(string))
        {
            MessageId = messageId;
            MessageVersion = messageVersion;
            MessageRelease = messageRelease;
            DataElementSeparator = dataElementSeparator;
            ComponentSeparator = componentSeparator;
            SegmentTerminator = segmentTerminator;
            RepetitionSeparator = repetitionSeparator;
            SegmentTerminatorSuffix = segmentTerminatorSuffix;
            DecimalPointIndicator = decimalPointIndicator;
            ReleaseIndicator = releaseIndicator;
            MessageAssociationAssignedCode = messageAssociationAssignedCode;
            TargetNamespace = targetNamespace;
        }

        /// <summary>
        /// Gets or sets the message id.
        /// </summary>
        [JsonProperty(PropertyName = "messageId")]
        public string MessageId { get; set; }

        /// <summary>
        /// Gets or sets the message version.
        /// </summary>
        [JsonProperty(PropertyName = "messageVersion")]
        public string MessageVersion { get; set; }

        /// <summary>
        /// Gets or sets the message releaseversion.
        /// </summary>
        [JsonProperty(PropertyName = "messageRelease")]
        public string MessageRelease { get; set; }

        /// <summary>
        /// Gets or sets the data element separator.
        /// </summary>
        [JsonProperty(PropertyName = "dataElementSeparator")]
        public int? DataElementSeparator { get; set; }

        /// <summary>
        /// Gets or sets the component separator.
        /// </summary>
        [JsonProperty(PropertyName = "componentSeparator")]
        public int? ComponentSeparator { get; set; }

        /// <summary>
        /// Gets or sets the segment terminator.
        /// </summary>
        [JsonProperty(PropertyName = "segmentTerminator")]
        public int? SegmentTerminator { get; set; }

        /// <summary>
        /// Gets or sets the repetition separator.
        /// </summary>
        [JsonProperty(PropertyName = "repetitionSeparator")]
        public int? RepetitionSeparator { get; set; }

        /// <summary>
        /// Gets or sets the segment terminator suffix. Possible values
        /// include: 'NotSpecified', 'None', 'CR', 'LF', 'CRLF'
        /// </summary>
        [JsonProperty(PropertyName = "segmentTerminatorSuffix")]
        public SegmentTerminatorSuffix? SegmentTerminatorSuffix { get; set; }

        /// <summary>
        /// Gets or sets the decimal point indicator. Possible values include:
        /// 'NotSpecified', 'Comma', 'Decimal'
        /// </summary>
        [JsonProperty(PropertyName = "decimalPointIndicator")]
        public EdifactDecimalIndicator? DecimalPointIndicator { get; set; }

        /// <summary>
        /// Gets or sets the release indicator.
        /// </summary>
        [JsonProperty(PropertyName = "releaseIndicator")]
        public int? ReleaseIndicator { get; set; }

        /// <summary>
        /// Gets or sets the message association assigned code.
        /// </summary>
        [JsonProperty(PropertyName = "messageAssociationAssignedCode")]
        public string MessageAssociationAssignedCode { get; set; }

        /// <summary>
        /// Gets or sets the target namespace on which this delimiter settings
        /// has to be applied.
        /// </summary>
        [JsonProperty(PropertyName = "targetNamespace")]
        public string TargetNamespace { get; set; }

    }
}
