// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Contains sku in an ExpressRouteCircuit
    /// </summary>
    public partial class ExpressRouteCircuitSku
    {
        /// <summary>
        /// Initializes a new instance of the ExpressRouteCircuitSku class.
        /// </summary>
        public ExpressRouteCircuitSku() { }

        /// <summary>
        /// Initializes a new instance of the ExpressRouteCircuitSku class.
        /// </summary>
        public ExpressRouteCircuitSku(string name = default(string), string tier = default(string), string family = default(string))
        {
            Name = name;
            Tier = tier;
            Family = family;
        }

        /// <summary>
        /// Gets or sets name of the sku.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets tier of the sku. Possible values include: 'Standard',
        /// 'Premium'
        /// </summary>
        [JsonProperty(PropertyName = "tier")]
        public string Tier { get; set; }

        /// <summary>
        /// Gets or sets family of the sku. Possible values include:
        /// 'UnlimitedData', 'MeteredData'
        /// </summary>
        [JsonProperty(PropertyName = "family")]
        public string Family { get; set; }

    }
}
