// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ResourceManager.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Export resource group template request parameters.
    /// </summary>
    public partial class ExportTemplateRequest
    {
        /// <summary>
        /// Initializes a new instance of the ExportTemplateRequest class.
        /// </summary>
        public ExportTemplateRequest() { }

        /// <summary>
        /// Initializes a new instance of the ExportTemplateRequest class.
        /// </summary>
        public ExportTemplateRequest(IList<string> resources = default(IList<string>), string options = default(string))
        {
            Resources = resources;
            Options = options;
        }

        /// <summary>
        /// The ids of the resources. The only supported string currently is
        /// '*' (all resources). Future api updates will support exporting
        /// specific resources.
        /// </summary>
        [JsonProperty(PropertyName = "resources")]
        public IList<string> Resources { get; set; }

        /// <summary>
        /// The export template options. Supported values include
        /// 'IncludeParameterDefaultValue', 'IncludeComments' or
        /// 'IncludeParameterDefaultValue, IncludeComments
        /// </summary>
        [JsonProperty(PropertyName = "options")]
        public string Options { get; set; }

    }
}
