// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// A top level domain object
    /// </summary>
    public partial class TopLevelDomain : Resource
    {
        /// <summary>
        /// Initializes a new instance of the TopLevelDomain class.
        /// </summary>
        public TopLevelDomain() { }

        /// <summary>
        /// Initializes a new instance of the TopLevelDomain class.
        /// </summary>
        public TopLevelDomain(string location, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string topLevelDomainName = default(string), bool? privacy = default(bool?))
            : base(location, id, name, type, tags)
        {
            TopLevelDomainName = topLevelDomainName;
            Privacy = privacy;
        }

        /// <summary>
        /// Name of the top level domain
        /// </summary>
        [JsonProperty(PropertyName = "properties.name")]
        public string TopLevelDomainName { get; set; }

        /// <summary>
        /// If true then the top level domain supports domain privacy
        /// </summary>
        [JsonProperty(PropertyName = "properties.privacy")]
        public bool? Privacy { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
