// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Defines how the Suggest API should apply to a group of fields in the
    /// index.
    /// </summary>
    public partial class Suggester
    {
        /// <summary>
        /// Initializes a new instance of the Suggester class.
        /// </summary>
        public Suggester() { }

        /// <summary>
        /// Initializes a new instance of the Suggester class.
        /// </summary>
        public Suggester(string name, SuggesterSearchMode searchMode, IList<string> sourceFields)
        {
            Name = name;
            SearchMode = searchMode;
            SourceFields = sourceFields;
        }

        /// <summary>
        /// Gets or sets the name of the suggester.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets a value indicating the capabilities of the suggester.
        /// Possible values include: 'analyzingInfixMatching'
        /// </summary>
        [JsonProperty(PropertyName = "searchMode")]
        public SuggesterSearchMode SearchMode { get; set; }

        /// <summary>
        /// Gets or sets the list of field names to which the suggester
        /// applies. Each field must be searchable.
        /// </summary>
        [JsonProperty(PropertyName = "sourceFields")]
        public IList<string> SourceFields { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (SourceFields == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SourceFields");
            }
        }
    }
}
